"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _react = _interopRequireWildcard(require("react"));
var _core = require("@dnd-kit/core");
var _sortable = require("@dnd-kit/sortable");
var _DnDItem = _interopRequireDefault(require("./DnDItem"));
var _excluded = ["items", "setItems", "templateItem"];
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
var DnDList = function DnDList(_ref) {
  var items = _ref.items,
    setItems = _ref.setItems,
    _ref$templateItem = _ref.templateItem,
    templateItem = _ref$templateItem === void 0 ? function () {} : _ref$templateItem,
    props = _objectWithoutProperties(_ref, _excluded);
  var itemsFormatted = (0, _react.useMemo)(function () {
    items.forEach(function (i) {
      if (i.id == null) {
        i.id = Date.now() * Math.random();
      }
    });
    return items;
  }, [items]);
  var onDragEnd = function onDragEnd(event) {
    var active = event.active,
      over = event.over;
    if (active.id !== over.id) {
      var oldIndex = itemsFormatted.findIndex(function (i) {
        return i.id === active.id;
      });
      var newIndex = itemsFormatted.findIndex(function (i) {
        return i.id === over.id;
      });
      setItems((0, _sortable.arrayMove)(items, oldIndex, newIndex));
    }
  };
  return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement(_core.DndContext, {
    onDragEnd: onDragEnd,
    collisionDetection: _core.closestCenter
  }, /*#__PURE__*/_react["default"].createElement(_sortable.SortableContext, {
    items: items
  }, items.map(function (item, index) {
    return /*#__PURE__*/_react["default"].createElement(_DnDItem["default"], {
      key: index,
      item: item,
      index: index,
      templateItem: templateItem
    });
  }))));
};
var _default = exports["default"] = DnDList;